#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_FILM 100
#define MAX_SALE 10

/* Struttura per memorizzare le informazioni sulle proiezioni */
typedef struct {
	char titolo[31];
	char sala[21];
	int ore[3];
} Proiezione;

/* Struttura per memorizzare le informazioni sulle sale */
typedef struct {
	char nome[21];
	float costo;
} Sala;

/* Strutture per memorizzare le informazione sui film per la biglietteria */ 
typedef struct {
	char titolo[31];
	float costo;
} Film;

/* procedura per leggere i dati da file */
int load(FILE* programma, FILE* sale, Film y[]) {
	int nfilm, nsale;
	int i, j;
	Proiezione p[MAX_FILM];
	Sala s[MAX_SALE];
	Proiezione tp;
	Sala ts;
	
	/* leggo i dati sul programma */
	nfilm = 0;
	while (fscanf(programma, "%s%s%d-%d-%d",
				  tp.titolo, tp.sala,
				  &tp.ore[0], &tp.ore[1], &tp.ore[2]) == 5) {
		p[nfilm] = tp;
		nfilm++;
	}
	
	/* leggo i dati sulle sale */
	nsale = 0;
	while (fscanf(sale, "%s%f", ts.nome, &ts.costo) == 2) {
		s[nsale] = ts;
		nsale++;
	}
	
	/* associo i dati sui film per ottenere il risultato */
	for (i = 0; i < nfilm; i++) {
		strcpy(y[i].titolo, p[i].titolo);
		for (j = 0; j < nsale; j++) {
			if (strcmp(p[i].sala, s[j].nome) == 0) {
				y[i].costo = s[j].costo;
			}
		}
	}
	
	/* restituisco il numero di film */
	return nfilm;
}

/* programma principale */
int main() {
	/* preparo le variabili */
	Film prezzi[MAX_FILM];
	FILE *programma, *sale;
	int i, nfilm;
	float costo_medio;
	
	/* apro il file con il programma */
	if ((programma = fopen("cineprogramma.txt", "r")) == NULL)
		exit(1);
	/* apro il file con le sale */
	if ((sale = fopen("sale.txt", "r")) == NULL)
		exit(1);

	/* leggo i dati sui film */
	nfilm = load(programma, sale, prezzi);
	
	/* chiudo i files */
	fclose(programma);
	fclose(sale);
	
	/* calcolo la media dei costi */
	costo_medio = 0;
	for (i = 0; i < nfilm; i++)
		costo_medio += prezzi[i].costo;
	costo_medio /= nfilm;
	
	/* stampo a video i dati sui film economici */
	for (i = 0; i < nfilm; i++) {
		if (prezzi[i].costo < costo_medio)
			printf("%s, costo: %f\n", prezzi[i].titolo, prezzi[i].costo);
	}
}
